searchNodes=[{"doc":"Generate Elixir code from .proto files. Arguments file - One or more .proto files to compile Required options --output-path - Path to output directory Optional options --include-path - Specify the directory in which to search for imports. Eqvivalent to protoc -I flag. --tranform-module - Module to do custom encoding/decoding for messages. See Protobuf.TransformModule for details. --package-prefix - Prefix generated Elixir modules. For example prefix modules with: MyApp.Protos use --package-prefix=my_app.protos . --generate-descriptors - Includes raw descriptors in the generated modules --one-file-per-module - Changes the way files are generated into directories. This option creates a file for each generated Elixir module. --include-documentation - Controls visibility of documentation of the generated modules. Setting true will not have @moduleoc false --plugins - If you write services in protobuf, you can generate gRPC code by passing --plugins=grpc . Examples $ mix protobuf.generate --output-path=./lib --include-path=./priv/protos helloworld.proto $ mix protobuf.generate --include-path=priv/proto --include-path=deps/googleapis --generate-descriptors=true --output-path=./lib --plugins=ProtobufGenerate.Plugins.GRPC google/api/annotations.proto google/api/http.proto helloworld.proto","ref":"Mix.Tasks.Protobuf.Generate.html","title":"Mix.Tasks.Protobuf.Generate","type":"task"},{"doc":"Plugins are modules which can used to hook in to code generation. A plugin is a module that provides template/0 and a generate/2 callbacks. defmodule GeneratePlugin do @behaviour ProtobufGenerate.Plugin alias Protobuf.Protoc.Generator.Util def template do &quot;&quot;&quot; defmodule &lt;%= @module %&gt; do def descriptor do &lt;%= @descriptor_body %&gt; end end &quot;&quot;&quot; end def generate ( ctx , % Google.Protobuf.FileDescriptorProto { } = desc ) do mod_name = Util . mod_name ( ctx , desc . name ) descriptor_body = Util . descriptor_fun_body ( desc ) { mod_name , module : mod_name , descriptor_body : descriptor_body } end end As an example the ProtobufGenerate.Plugin.GRPCWithOptions plugin is implemented as: defmodule ProtobufGenerate.Plugins.GRPCWithOptions do @behaviour ProtobufGenerate.Plugin alias Protobuf.Protoc.Generator.Util @impl true def template do &quot;&quot;&quot; defmodule &lt;%= @module %&gt;.Service do @moduledoc false use GRPC.Service, name: &lt;%= inspect(@service_name) %&gt;, protoc_gen_elixir_version: &quot;&lt;%= @version %&gt;&quot; &lt;%= if @descriptor_fun_body do %&gt; def descriptor do # credo:disable-for-next-line &lt;%= @descriptor_fun_body %&gt; end &lt;% end %&gt; &lt;%= for {method_name, input, output, options} &lt;- @methods do %&gt; rpc :&lt;%= method_name %&gt;, &lt;%= input %&gt;, &lt;%= output %&gt;, &lt;%= options %&gt; &lt;% end %&gt; end &quot;&quot;&quot; end @impl true def generate ( ctx , % Google.Protobuf.FileDescriptorProto { service : svcs } = desc ) do for svc &lt;- svcs do mod_name = Util . mod_name ( ctx , [ Macro . camelize ( svc . name ) ] ) name = Util . prepend_package_prefix ( ctx . package , svc . name ) descriptor_fun_body = if ctx . gen_descriptors? do Util . descriptor_fun_body ( desc ) else nil end methods = for m &lt;- svc . method do input = service_arg ( Util . type_from_type_name ( ctx , m . input_type ) , m . client_streaming ) output = service_arg ( Util . type_from_type_name ( ctx , m . output_type ) , m . server_streaming ) options = m . options |&gt; opts ( ) |&gt; inspect ( limit : :infinity ) { m . name , input , output , options } end { mod_name , [ module : mod_name , service_name : name , methods : methods , descriptor_fun_body : descriptor_fun_body , version : Util . version ( ) ] } end end defp service_arg ( type , _streaming? = true ) , do : &quot;stream( \#{ type } )&quot; defp service_arg ( type , _streaming? ) , do : type defp opts ( % Google.Protobuf.MethodOptions { __pb_extensions__ : extensions } ) when extensions == %{ } do %{ } end defp opts ( % Google.Protobuf.MethodOptions { __pb_extensions__ : extensions } ) do for { { type , field } , value } &lt;- extensions , into : %{ } do { field , %{ type : type , value : value } } end end end","ref":"ProtobufGenerate.Plugin.html","title":"ProtobufGenerate.Plugin","type":"behaviour"},{"doc":"","ref":"ProtobufGenerate.Plugin.html#c:generate/2","title":"ProtobufGenerate.Plugin.generate/2","type":"callback"},{"doc":"","ref":"ProtobufGenerate.Plugin.html#load/1","title":"ProtobufGenerate.Plugin.load/1","type":"function"},{"doc":"","ref":"ProtobufGenerate.Plugin.html#c:template/0","title":"ProtobufGenerate.Plugin.template/0","type":"callback"},{"doc":"","ref":"ProtobufGenerate.Plugin.html#t:state/0","title":"ProtobufGenerate.Plugin.state/0","type":"type"},{"doc":"","ref":"ProtobufGenerate.Plugin.html#t:template_assigns/0","title":"ProtobufGenerate.Plugin.template_assigns/0","type":"type"},{"doc":"Plugin to Generate gRPC code from protbuf service definitions","ref":"ProtobufGenerate.Plugins.GRPC.html","title":"ProtobufGenerate.Plugins.GRPC","type":"module"},{"doc":"Plugin to Generate gRPC code from protbuf service definitions, this plugin outputs any extension options on service methods as a param to GRPC.Service.rpc/4","ref":"ProtobufGenerate.Plugins.GRPCWithOptions.html","title":"ProtobufGenerate.Plugins.GRPCWithOptions","type":"module"},{"doc":"protobuf.generate is a mix task that allows you to generate Elixir code using Protobuf without using the protoc-gen-elixir plugin. The generator calls protoc using descriptor_set_out to output a FileDescriptorSet into a temporary file for input to Protobuf . The difference between protobuf.generate and protoc-gen-elixir is that protoc-gen-elixir is called as a plugin to protoc and therefor executes in a global context while protobuf.generate executes in the context of the local project. By executing in the context of the local project: Extensions that needs to be populated during code generation are picked up automatically by Protobuf.load_extensions/0 (which is not possible when using protoc-gen-elixir ). Integration into the codegen by using generator plugins. See ProtobufGenerate.Plugin","ref":"readme.html","title":"Protobuf.Generate","type":"extras"},{"doc":"Protoc (protocol buffer compiler) is required to be installed. Download and install the protocol buffer compiler (protoc).","ref":"readme.html#prerequisites","title":"Protobuf.Generate - Prerequisites","type":"extras"},{"doc":"This package can be installed by adding protobuf_generate to your list of dependencies in mix.exs : def deps do [ { :protobuf_generate , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Protobuf.Generate - Installation","type":"extras"},{"doc":"mix protobuf.generate supports the same options as protoc-gen-elixir Arguments file - One or more .proto files to compile Required options --output-path - Path to output directory Optional options --include-path - Specify the directory in which to search for imports. Eqvivalent to protoc -I flag. --tranform-module - Module to do custom encoding/decoding for messages. See Protobuf.TransformModule for details. --package-prefix - Prefix generated Elixir modules. For example prefix modules with: MyApp.Protos use --package-prefix=my_app.protos . --generate-descriptors - Includes raw descriptors in the generated modules --one-file-per-module - Changes the way files are generated into directories. This option creates a file for each generated Elixir module. --include-documentation - Controls visibility of documentation of the generated modules. Setting true will not have @moduleoc false --plugins - Generator plugins. If you write services in protobuf, you can generate gRPC code by passing --plugins=ProtobufGenerate.Plugins.GRPC . $ mix protobuf.generate --output-path=./lib --include-path=./priv/protos helloworld.proto $ mix protobuf.generate \\ --include-path=priv/proto \\ --include-path=deps/googleapis \\ --generate-descriptors=true \\ --output-path=./lib \\ --plugins=ProtobufGenerate.Plugins.GRPCWithOptions \\ google/api/annotations.proto google/api/http.proto helloworld.proto","ref":"readme.html#usage","title":"Protobuf.Generate - Usage","type":"extras"},{"doc":"ProtobufGenerate.Plugins.GRPC - Generate gRPC services ProtobufGenerate.Plugins.GRPCWithOptions - Generate gRPC services with method extension options.","ref":"readme.html#available-plugins","title":"Protobuf.Generate - Available plugins","type":"extras"},{"doc":"Extensions in the current project are loaded automatically when running mix protobuf.generate . However they need to be already generated in order for Protobuf.load_extensions/0 to pick them up.","ref":"readme.html#extensions","title":"Protobuf.Generate - Extensions","type":"extras"},{"doc":"protox for running protoc with descriptor_set_out","ref":"readme.html#acknowledgements","title":"Protobuf.Generate - Acknowledgements","type":"extras"}]